/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.enums.EnumIsocode;
import de.ship.db.enums.EnumTransCategory;
import de.ship.db.tables.records.VCoreTranslationFullRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreTranslationFull extends TableImpl<VCoreTranslationFullRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_core_translation_full</code>
     */
    public static final VCoreTranslationFull V_CORE_TRANSLATION_FULL = new VCoreTranslationFull();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreTranslationFullRecord> getRecordType() {
        return VCoreTranslationFullRecord.class;
    }

    /**
     * The column
     * <code>common_dd.v_core_translation_full.pk_core_translationkey</code>.
     */
    public final TableField<VCoreTranslationFullRecord, Integer> PK_CORE_TRANSLATIONKEY = createField(DSL.name("pk_core_translationkey"), SQLDataType.INTEGER, this, "");

    /**
     * The column
     * <code>common_dd.v_core_translation_full.pk_core_translation</code>.
     */
    public final TableField<VCoreTranslationFullRecord, Integer> PK_CORE_TRANSLATION = createField(DSL.name("pk_core_translation"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_translation_full.fk_trans_key</code>.
     */
    public final TableField<VCoreTranslationFullRecord, String> FK_TRANS_KEY = createField(DSL.name("fk_trans_key"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_translation_full.isocode</code>.
     */
    public final TableField<VCoreTranslationFullRecord, EnumIsocode> ISOCODE = createField(DSL.name("isocode"), SQLDataType.VARCHAR.asEnumDataType(EnumIsocode.class), this, "");

    /**
     * The column <code>common_dd.v_core_translation_full.category</code>.
     */
    public final TableField<VCoreTranslationFullRecord, EnumTransCategory> CATEGORY = createField(DSL.name("category"), SQLDataType.VARCHAR.asEnumDataType(EnumTransCategory.class), this, "");

    /**
     * The column <code>common_dd.v_core_translation_full.value</code>.
     */
    public final TableField<VCoreTranslationFullRecord, String> VALUE = createField(DSL.name("value"), SQLDataType.CLOB, this, "");

    private VCoreTranslationFull(Name alias, Table<VCoreTranslationFullRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreTranslationFull(Name alias, Table<VCoreTranslationFullRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_translation_full" as  SELECT pk_core_translationkey,
          pk_core_translation,
          fk_trans_key,
          isocode,
          category,
          value
         FROM common_dd.v_core_translation
        WHERE (category = 'full'::common_dd.enum_trans_category);
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_translation_full</code> table
     * reference
     */
    public VCoreTranslationFull(String alias) {
        this(DSL.name(alias), V_CORE_TRANSLATION_FULL);
    }

    /**
     * Create an aliased <code>common_dd.v_core_translation_full</code> table
     * reference
     */
    public VCoreTranslationFull(Name alias) {
        this(alias, V_CORE_TRANSLATION_FULL);
    }

    /**
     * Create a <code>common_dd.v_core_translation_full</code> table reference
     */
    public VCoreTranslationFull() {
        this(DSL.name("v_core_translation_full"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreTranslationFull as(String alias) {
        return new VCoreTranslationFull(DSL.name(alias), this);
    }

    @Override
    public VCoreTranslationFull as(Name alias) {
        return new VCoreTranslationFull(alias, this);
    }

    @Override
    public VCoreTranslationFull as(Table<?> alias) {
        return new VCoreTranslationFull(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreTranslationFull rename(String name) {
        return new VCoreTranslationFull(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreTranslationFull rename(Name name) {
        return new VCoreTranslationFull(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreTranslationFull rename(Table<?> name) {
        return new VCoreTranslationFull(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreTranslationFull where(Condition condition) {
        return new VCoreTranslationFull(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreTranslationFull where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreTranslationFull where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreTranslationFull where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreTranslationFull where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreTranslationFull where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreTranslationFull where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreTranslationFull where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreTranslationFull whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreTranslationFull whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
